package org.jeecg.modules.projectManagement.controller;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.projectManagement.entity.FdBioanalysisSampleMilestonesItems;
import org.jeecg.modules.projectManagement.entity.FdBioanalysisSampleMilestonesItemsTree;
import org.jeecg.modules.projectManagement.entity.FdProjectQuotationTemplateItem;
import org.jeecg.modules.projectManagement.service.IFdBioanalysisSampleMilestonesItemsService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.projectManagement.service.IFdProjectQuotationTemplateItemService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

/**
 * @Title: Controller
 * @Description: 生物分析样本里程碑明细
 * @author： jeecg-boot
 * @date： 2019-06-04
 * @version： V1.0
 */
@RestController
@RequestMapping("/projectManagement/fdBioanalysisSampleMilestonesItems")
@Slf4j
public class FdBioanalysisSampleMilestonesItemsController {
    @Autowired
    private IFdBioanalysisSampleMilestonesItemsService fdBioanalysisSampleMilestonesItemsService;
    @Autowired
    private IFdProjectQuotationTemplateItemService iFdProjectQuotationTemplateItemService;

    /**
     * 分页列表查询
     *
     * @param fdBioanalysisSampleMilestonesItems
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @GetMapping(value = "/list")
    public Result<IPage<FdBioanalysisSampleMilestonesItems>> queryPageList(FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems,
                                                                           @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                           @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                                           HttpServletRequest req) {
        Result<IPage<FdBioanalysisSampleMilestonesItems>> result = new Result<IPage<FdBioanalysisSampleMilestonesItems>>();
        QueryWrapper<FdBioanalysisSampleMilestonesItems> queryWrapper = QueryGenerator.initQueryWrapper(fdBioanalysisSampleMilestonesItems, req.getParameterMap());
        Page<FdBioanalysisSampleMilestonesItems> page = new Page<FdBioanalysisSampleMilestonesItems>(pageNo, pageSize);
        IPage<FdBioanalysisSampleMilestonesItems> pageList = fdBioanalysisSampleMilestonesItemsService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param fdBioanalysisSampleMilestonesItems
     * @return
     */
    @PostMapping(value = "/add")
    public Result<FdBioanalysisSampleMilestonesItems> add(@RequestBody FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems) {
        Result<FdBioanalysisSampleMilestonesItems> result = new Result<FdBioanalysisSampleMilestonesItems>();
        try {
            fdBioanalysisSampleMilestonesItemsService.save(fdBioanalysisSampleMilestonesItems);
            result.success("添加成功！");
        } catch (Exception e) {
            e.printStackTrace();
            log.info(e.getMessage());
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param fdBioanalysisSampleMilestonesItems
     * @return
     */
    @PutMapping(value = "/edit")
    public Result<FdBioanalysisSampleMilestonesItems> edit(@RequestBody FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems) {
        Result<FdBioanalysisSampleMilestonesItems> result = new Result<FdBioanalysisSampleMilestonesItems>();
        FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItemsEntity = fdBioanalysisSampleMilestonesItemsService.getById(fdBioanalysisSampleMilestonesItems.getId());
        if (fdBioanalysisSampleMilestonesItemsEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = fdBioanalysisSampleMilestonesItemsService.updateById(fdBioanalysisSampleMilestonesItems);
            //TODO 返回false说明什么？
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @DeleteMapping(value = "/delete")
    public Result<FdBioanalysisSampleMilestonesItems> delete(@RequestParam(name = "id", required = true) String id) {
        Result<FdBioanalysisSampleMilestonesItems> result = new Result<FdBioanalysisSampleMilestonesItems>();
        FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems = fdBioanalysisSampleMilestonesItemsService.getById(id);
        if (fdBioanalysisSampleMilestonesItems == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = fdBioanalysisSampleMilestonesItemsService.removeById(id);
            if (ok) {
                result.success("删除成功!");
            }
        }

        return result;
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @DeleteMapping(value = "/deleteBatch")
    public Result<FdBioanalysisSampleMilestonesItems> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<FdBioanalysisSampleMilestonesItems> result = new Result<FdBioanalysisSampleMilestonesItems>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.fdBioanalysisSampleMilestonesItemsService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @GetMapping(value = "/queryById")
    public Result<FdBioanalysisSampleMilestonesItems> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<FdBioanalysisSampleMilestonesItems> result = new Result<FdBioanalysisSampleMilestonesItems>();
        FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems = fdBioanalysisSampleMilestonesItemsService.getById(id);
        if (fdBioanalysisSampleMilestonesItems == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(fdBioanalysisSampleMilestonesItems);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<FdBioanalysisSampleMilestonesItems> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems = JSON.parseObject(deString, FdBioanalysisSampleMilestonesItems.class);
                queryWrapper = QueryGenerator.initQueryWrapper(fdBioanalysisSampleMilestonesItems, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<FdBioanalysisSampleMilestonesItems> pageList = fdBioanalysisSampleMilestonesItemsService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "生物分析样本里程碑明细列表");
        mv.addObject(NormalExcelConstants.CLASS, FdBioanalysisSampleMilestonesItems.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("生物分析样本里程碑明细列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();// 获取上传文件对象
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<FdBioanalysisSampleMilestonesItems> listFdBioanalysisSampleMilestonesItemss = ExcelImportUtil.importExcel(file.getInputStream(), FdBioanalysisSampleMilestonesItems.class, params);
                for (FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItemsExcel : listFdBioanalysisSampleMilestonesItemss) {
                    fdBioanalysisSampleMilestonesItemsService.save(fdBioanalysisSampleMilestonesItemsExcel);
                }
                return Result.ok("文件导入成功！数据行数：" + listFdBioanalysisSampleMilestonesItemss.size());
            } catch (Exception e) {
                log.error(e.getMessage());
                return Result.error("文件导入失败！");
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }


    /**
     * @return org.jeecg.common.api.vo.Result<java.util.List < org.jeecg.modules.projectManagement.entity.FdBioanalysisSampleMilestonesItemsTree>>
     * @Author gurui
     * @Description //TODO 父子集查询
     * @Date 9:38 2019/6/21
     * @Param [templateId]
     **/
    @GetMapping(value = "/queryTreeList")
    public Result<List<FdBioanalysisSampleMilestonesItemsTree>> queryTreeList(String templateId) {
        Result<List<FdBioanalysisSampleMilestonesItemsTree>> result = new Result<>();
        try {
            LambdaQueryWrapper<FdBioanalysisSampleMilestonesItems> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(FdBioanalysisSampleMilestonesItems::getTemplateId, templateId);
            lambdaQueryWrapper.orderByAsc(FdBioanalysisSampleMilestonesItems::getCode);
            List<FdBioanalysisSampleMilestonesItems> list = fdBioanalysisSampleMilestonesItemsService.list(lambdaQueryWrapper);
            List<FdBioanalysisSampleMilestonesItemsTree> treeLists = new ArrayList<>();
            getTreeList(treeLists, list, null);
            findLeaf(treeLists);
            result.setResult(treeLists);
        } catch (Exception e) {
            e.fillInStackTrace();
        }
        return result;
    }

    private void getTreeList(List<FdBioanalysisSampleMilestonesItemsTree> treeList, List<FdBioanalysisSampleMilestonesItems> fdlist, FdBioanalysisSampleMilestonesItemsTree temp) {
        for (FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems : fdlist) {
            String tempPid = fdBioanalysisSampleMilestonesItems.getParentId();
            FdBioanalysisSampleMilestonesItemsTree tree = new FdBioanalysisSampleMilestonesItemsTree(fdBioanalysisSampleMilestonesItems);
            if (temp == null && oConvertUtils.isEmpty(tempPid)) {
                treeList.add(tree);
                if (!tree.getIsLeaf()) {
                    getTreeList(treeList, fdlist, tree);
                }
            } else if (temp != null && tempPid != null && tempPid.equals(temp.getId())) {
                temp.getChildren().add(tree);
                if (!tree.getIsLeaf()) {
                    getTreeList(treeList, fdlist, tree);
                }
            }
        }
    }

    private void findLeaf(List<FdBioanalysisSampleMilestonesItemsTree> treeList) {
        for (FdBioanalysisSampleMilestonesItemsTree fdBioanalysisSampleMilestonesItemsTree : treeList) {
            //用于树形的swith
            //是否关键点
            if(fdBioanalysisSampleMilestonesItemsTree.getIsKeypoint().equals("1")){
                fdBioanalysisSampleMilestonesItemsTree.setKeypointBoolean(true);
            }else{
                fdBioanalysisSampleMilestonesItemsTree.setKeypointBoolean(false);
            }

            //是否付款里程碑
            if(fdBioanalysisSampleMilestonesItemsTree.getIsPayMilestones().equals("1")){
                fdBioanalysisSampleMilestonesItemsTree.setPayMilestonesBoolean(true);
            }else{
                fdBioanalysisSampleMilestonesItemsTree.setPayMilestonesBoolean(false);
            }

            //是否上传文档
            if(fdBioanalysisSampleMilestonesItemsTree.getIsUploadFile().equals("1")){
                fdBioanalysisSampleMilestonesItemsTree.setUploadFileBoolean(true);
            }else{
                fdBioanalysisSampleMilestonesItemsTree.setUploadFileBoolean(false);
            }

            if (fdBioanalysisSampleMilestonesItemsTree.getChildren().isEmpty()) {
                fdBioanalysisSampleMilestonesItemsTree.setIsLeaf(true);
                fdBioanalysisSampleMilestonesItemsTree.setChildren(null);
            } else {
                findLeaf(fdBioanalysisSampleMilestonesItemsTree.getChildren());
            }
        }
    }

    /**
     * 获取里程碑中对应化合物与基质中的生物分析报价明细
     * @param fdBioanalysisSampleMilestonesItems
     * @return
     */
    @GetMapping(value = "/getBioProjectTempItem")
    public Result<List<FdProjectQuotationTemplateItem>> getBioProjectTempItem(FdBioanalysisSampleMilestonesItems fdBioanalysisSampleMilestonesItems){
        Result<List<FdProjectQuotationTemplateItem>> result=new Result<>();
        //生物分析模板明细
        List<FdProjectQuotationTemplateItem> fdProjectQuotationTemplateItemList=iFdProjectQuotationTemplateItemService.getBioTempItemsBycontractId(fdBioanalysisSampleMilestonesItems.getContractId());
        List<FdProjectQuotationTemplateItem> fdProjectQuotationTemplateItemListReturn=new ArrayList<>();
        //循环查找里程碑中对应化合物与基质下的明细
        for(FdProjectQuotationTemplateItem bioItem:fdProjectQuotationTemplateItemList){
            String quotationTemplateName=bioItem.getQuotationTemplateName();//报价模板名称
            String[] templateNames = quotationTemplateName.split("-");
            String compoundName=templateNames[1];//化合物名称
            String maxtriName=templateNames[2];//基质名称
            //判断是否数据找到该化合物与基质下的明细
            if(compoundName.equals(fdBioanalysisSampleMilestonesItems.getCompoundName())&&maxtriName.equals(fdBioanalysisSampleMilestonesItems.getMatrixTypeName())){
                fdProjectQuotationTemplateItemListReturn.add(bioItem);
            }
        }
        result.setResult(fdProjectQuotationTemplateItemListReturn);
        return result;
    }

}
